*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\COLR3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: COLOR3270()
*:
*:         Set by: HOST3270()         (function  in HOST3270.PRG)
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
*!*****************************************************************************
*!
*!       Function: COLOR3270()
*!
*!      Called by: HOST3270()         (function  in HOST3270.PRG)
*!               : SAVE3270()         (function  in SAVE3270.PRG)
*!               : SHOW3270()         (function  in SHOW3270.PRG)
*!
*!*****************************************************************************
FUNCTION Color3270( cAttrib, cColor )
*
*  Field attribute codes/color table for 3270 display.
*  This function initializes and maintains a table of colors
*  to be used for 3270 screen display.
*
*  Color3270( CHR(202) )          -> Returns color for attribute 202
*  Color3270( 9 )                 -> Returns color for table position 9
*  Color3270( CHR(244), "W*/N" )  -> Updates color for attribute 244
*
*   attribute   string
*   character   index     description
*   ----------  -------   -----------------------------
*   chr(192)     1        Edit Field 1 , Clear
*   chr(193)     2        Edit FIeld 1 , Keyed In
*   chr(200)     3        Edit Field 2 , Clear
*   chr(201)     4        Edit Field 2 , Keyed In
*   chr(202)     5        Hidden Edit Field 1, Clear
*   chr(203)     6        Hidden Edit Field 1, Keyed In
*   chr(204)     7        Hidden Edit Field 2, Clear
*   chr(205)     8        Hidden Edit Field 2, Keyed In
*   chr(224)     9        Normal Text 1
*   chr(232)    10        Normal Text 2
*   chr(240)    11        Normal Text 3
*   chr(244)    12        Bolded Text 1
*   chr(248)    13        Bolded Text 2
*
LOCAL nValue := 9          // default to normal text
STATIC aColors, cIndex     // variable to hold colors

IF cIndex == NIL
   cIndex := CHR(192)+CHR(193)+CHR(200)+CHR(201)+;
      CHR(202)+CHR(203)+CHR(204)+CHR(205)+;
      CHR(224)+CHR(232)+CHR(240)+CHR(244)+CHR(248)
ENDIF

IF aColors == NIL
   aColors := { "W/N", "W/N", "R+/N", "R/N", ;
      "N/N", "N/N", "N/N", "N/N", ;
      "BG+/N", "W+/N", "G/N", "W+/N", "W+/N" }
ENDIF

// convert attribute to number
IF VALTYPE( cAttrib ) == "C"
   nValue := AT( cAttrib, cIndex )
ENDIF

// make sure number is valid
IF nValue == 0 .OR. nValue > 13
   nValue := 9
ELSE
   // update attribute color if valid number and color sent
   IF VALTYPE( cColor ) == "C"
      aColors[ nValue ] := cColor
   ENDIF
ENDIF

RETURN aColors[ nValue ]

*: EOF: COLR3270.PRG
