*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\HOST3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: HOST3270()
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
#include "CLIP2.CH"
#include "INKEY.CH"

*!*****************************************************************************
*!
*!       Function: HOST3270()
*!
*!          Calls: COLOR3270()        (function  in COLR3270.PRG)
*!               : WRITE3270()        (function  in WRIT3270.PRG)
*!               : HELP3270()         (function  in HELP3270.PRG)
*!               : PROG3270()         (function  in PROG3270.PRG)
*!               : SAVE3270()         (function  in SAVE3270.PRG)
*!               : SHOW3270()         (function  in SHOW3270.PRG)
*!               : STAT3270()         (function  in STAT3270.PRG)
*!               : TURN3270()         (function  in TURN3270.PRG)
*!               : WRITEAT()          (function  in WRITEAT.PRG)
*!
*!*****************************************************************************
FUNCTION HOST3270( cSession, lSlowcpu, lDevelop )
* 11/03/92 - Use Clip2++ functions to access mainframe session.
* 03/09/93 - Made code faster by avoiding extra screen reads.
* 12/26/93 - Removed Stride Rite specific code so others can use these programs.
LOCAL nKey := 0, nRow := 0, nCol := 0, nLoop, nCurSpot
LOCAL cScreen := "1", cOldScrn := "2", cSaveScrn, aFlds := {}
LOCAL cOldColor, cCurColr := Color3270(9), nCurColr := 7
LOCAL lColor := .T., lAttrib, lEditable := .F.
LOCAL nOldAttr := CP2attrib()

* Default the parameters if not passed...
cSession := IF( VALTYPE( cSession ) <> "C", "E", cSession )
lSlowcpu := IF( VALTYPE( lSlowcpu ) <> "L", .F., lSlowcpu )
lDevelop := IF( VALTYPE( lDevelop ) <> "L", .F., lDevelop )

* Display attributes if PC is fast
lAttrib := !lSlowcpu

IF !TURN3270( "ON", cSession )
   RETURN .F.
ENDIF

cSaveScrn := SAVEBOX( 0, 0, 24, 79 )
cOldColor := SETCOLOR( cCurColr )

BEGIN SEQUENCE

   CP2attrib( IF( lAttrib, 1, 0 ) )

   SET CURSOR ON
   
   cScreen := CP2readall()
   DO WHILE nKey <> K_ESC .AND. NEXTKEY() <> K_ESC

      IF cScreen == cOldScrn
         * Do nothing... same screen
      ELSE
         cCurColr := Show3270( cScreen, lColor, .T. )
         cOldScrn := cScreen
         aFlds    := {}
      ENDIF
      * Check the position of the cursor on the mainframe.
      CP2AT( @nRow, @nCol )
      * Display cursor
      @ 24,74 SAY STR(nRow,2,0)+"/"+STR(nCol,2,0) COLOR "N/W"
      @ nRow-1, nCol-1 SAY ""
      * Get screen color at cursor position
      nCurColr := WhatColor()

      * Wait a second for a keypress
      IF nKey <> 251
         nKey := INKEY(.1)
      ENDIF
      
      DO CASE
      CASE nKey == 0;           cScreen := CP2readall(); LOOP    // no key pressed
      CASE nKey == K_ALT_1;     EXIT                             // exit emulation
      CASE nKey == K_ESC;       EXIT                             // exit emulation
      CASE nKey == K_TAB;       CP2sendkey( CP2kTAB ); LOOP      // Tab
      CASE nKey == K_SH_TAB;    CP2sendkey( CP2kBACK ); LOOP     // Back Tab
      CASE nKey == K_DOWN;      CP2sendkey( CP2kDOWN ); LOOP     // Cursor down
      CASE nKey == K_LEFT;      CP2sendkey( CP2kLEFT ); LOOP     // Cursor left
      CASE nKey == K_RIGHT;     CP2sendkey( CP2kRIGHT ); LOOP    // Cursor right
      CASE nKey == K_UP;        CP2sendkey( CP2kUP ); LOOP       // Cursor up
      CASE nKey == K_DEL;       CP2sendkey( CP2kDELETE )         // Delete
      CASE nKey == K_ENTER;     CP2sendkey( CP2kENTER )          // Enter
      CASE nKey == K_HOME;      CP2sendkey( CP2kHOME ); LOOP     // Home
      CASE nKey == K_INS;       CP2sendkey( CP2kINS )            // Insert
      CASE nKey == K_F1;        Help3270(); LOOP                 // Keyboard help
      CASE nKey == K_F2;        CP2sendkey( CP2kCLEAR )          // Clear
      CASE nKey == K_F3;        CP2sendkey( CP2kATTN )           // Attention
      CASE nKey == K_F4;        CP2sendkey( CP2kINPUT )          // Erase input
      CASE nKey == K_F5;        CP2sendkey( CP2kDUP )            // DUP
      CASE nKey == K_F6;        CP2sendkey( CP2kEOF )            // Erase EOF
      CASE nKey == K_F7;        CP2sendkey( CP2kPRINT )          // Print
      CASE nKey == K_F8;        CP2sendkey( CP2kSYSRQ )          // System Request
      CASE nKey == K_F9;        CP2sendkey( CP2kNLINE )          // New line
      CASE nKey == K_F10;       CP2sendkey( CP2kRESET )          // Reset
      CASE nKey == K_F11;       CP2sendkey( CP2kAID1 )           // PA1
      CASE nKey == K_F12;       CP2sendkey( CP2kAID2 )           // PA2
      CASE nKey == K_ALT_F1;    CP2sendkey( CP2kPF1 )            // PF1
      CASE nKey == K_ALT_F2;    CP2sendkey( CP2kPF2 )            // PF2
      CASE nKey == K_ALT_F3;    CP2sendkey( CP2kPF3 )            // PF3
      CASE nKey == K_ALT_F4;    CP2sendkey( CP2kPF4 )            // PF4
      CASE nKey == K_ALT_F5;    CP2sendkey( CP2kPF5 )            // PF5
      CASE nKey == K_ALT_F6;    CP2sendkey( CP2kPF6 )            // PF6
      CASE nKey == K_ALT_F7;    CP2sendkey( CP2kPF7 )            // PF7
      CASE nKey == K_ALT_F8;    CP2sendkey( CP2kPF8 )            // PF8
      CASE nKey == K_ALT_F9;    CP2sendkey( CP2kPF9 )            // PF9
      CASE nKey == K_ALT_F10;   CP2sendkey( CP2kPF10 )           // PF10
      CASE nKey == K_ALT_F11;   CP2sendkey( CP2kPF11 )           // PF11
      CASE nKey == K_ALT_F12;   CP2sendkey( CP2kPF12 )           // PF12
      CASE nKey == K_CTRL_F1;   CP2sendkey( CP2kPF13 )           // PF13
      CASE nKey == K_CTRL_F2;   CP2sendkey( CP2kPF14 )           // PF14
      CASE nKey == K_CTRL_F3;   CP2sendkey( CP2kPF15 )           // PF15
      CASE nKey == K_CTRL_F4;   CP2sendkey( CP2kPF16 )           // PF16
      CASE nKey == K_CTRL_F5;   CP2sendkey( CP2kPF17 )           // PF17
      CASE nKey == K_CTRL_F6;   CP2sendkey( CP2kPF18 )           // PF18
      CASE nKey == K_CTRL_F7;   CP2sendkey( CP2kPF19 )           // PF19
      CASE nKey == K_CTRL_F8;   CP2sendkey( CP2kPF20 )           // PF20
      CASE nKey == K_CTRL_F9;   CP2sendkey( CP2kPF21 )           // PF21
      CASE nKey == K_CTRL_F10;  CP2sendkey( CP2kPF22 )           // PF22
      CASE nKey == K_CTRL_F11;  CP2sendkey( CP2kPF23 )           // PF23
      CASE nKey == K_CTRL_F12;  CP2sendkey( CP2kPF24 )           // PF24
      CASE nKey == K_CTRL_J;    CP2sendkey( CP2kAID1 )           // PA1
      CASE nKey == K_CTRL_K;    CP2sendkey( CP2kAID2 )           // PA2
      CASE nKey == K_CTRL_RET;  CP2sendkey( CP2kNLINE )          // New line
      CASE nKey == K_ALT_F;     CP2sendkey( CP2kFLDMK )          // Field mark
      CASE nKey == ASC("#");    CP2sendkey( CP2kNOT )            // Not Sign
      CASE nKey == ASC("");    CP2sendkey( CP2kCENT )           // Cent Sign
      CASE nKey == ASC("|");    CP2sendkey( CP2kBAR )            // | Bar Sign
      CASE nKey == ASC("@");    CP2sendkey( CP2kAT )             // @

      CASE BETWEEN( nKey, 32, 122 ) .OR. nKey = 251 // valid letter or number
         lEditable := IF(CP2fprot() = 0, .T., .F. )
         nCurSpot  := CP2PN()
         DO WHILE .T.

            IF nKey == 251
               * Process more keys
               DO WHILE NEXTKEY() == 0
               ENDDO
               IF BETWEEN( NEXTKEY(), 32, 122 )
                  nKey := INKEY()
               ELSE
                  EXIT
               ENDIF
            ENDIF
            
            * Only allow entry in unprotected fields.
            IF lEditable
               * Send keystroke to the mainframe.
               CP2sendkey( CHR( nKey ) )
               nCurSpot ++
               * Check current screen color for hidden/protected fields.
               * Protected fields are usually N/N.  Foreground and
               * background colors are the same to hide data entry.
               * WhatColor() returns the color as a combined value of
               * foreground + background.  There are 15 foreground colors
               * available so the color table increments by 16.  We can
               * determine if a color is hidden if it is divisible by 16.
               IF nCurColr == 0 .OR. INT(nCurColr/16) == nCurColr/16
                  * display something on the screen to show keystrokes
                  @ ROW(), COL() SAY "*" COLOR "W/N"
               ELSE
                  * display the actual key pressed
                  @ ROW(), COL() SAY CHR( nKey ) COLOR cCurColr
               ENDIF
            ELSE
               TONE(100,1)
               EXIT
            ENDIF

            * Check to see if the cursor jumped to a new field
            CP2AT( @nRow, @nCol )
            IF CP2PNAT( nRow, nCol ) <> nCurSpot
               nKey := 251
               EXIT
            ELSE
               @ 24,74 SAY STR(nRow,2,0)+"/"+STR(nCol,2,0) COLOR "N/W"
               @ nRow-1, nCol-1 SAY ""
            ENDIF
            
            * Process more keys
            DO WHILE NEXTKEY() == 0
            ENDDO
            IF BETWEEN( NEXTKEY(), 32, 122 )
               nKey := INKEY()
            ELSE
               EXIT
            ENDIF

         ENDDO
         
         * If the next key is Enter - press it!
         IF NEXTKEY() == K_ENTER
            nKey := INKEY()
            CP2sendkey( CP2kENTER )
         ENDIF

         /////////////////////////////////////////////////////////////////
         /////////////////////////////////////////////////////////////////

         * Disable attributes on slow computers
      CASE nKey == K_ALT_A       // change color and attribute settings
         DO CASE
         CASE lAttrib .AND. lColor
            lAttrib := .F.
            lColor  := .F.
         CASE !lAttrib .AND. !lColor
            lAttrib := .T.
            lColor  := .F.
         CASE lAttrib
            lAttrib := .T.
            lColor  := .T.
         ENDCASE
         IF lSlowcpu
            * Do not allow attribute change on slow computers
         ELSE
            CP2attrib( IF( lAttrib, 1, 0 ) )    // set attribute value
            cOldScrn := "clear"                 // "reset" screen variable
         ENDIF
         
      CASE nKey == K_ALT_R .AND. lDevelop    // pop-up ruler
         RULER( 1, 1 )

      CASE nKey == K_ALT_P .AND. lDevelop    // write program to edit screen
         IF LEN( aFlds ) == 0
            Alert( "No screen information saved yet!", {"OK"} )
         ELSE
            Prog3270( "hostscrn.prg", cScreen, aFlds )
         ENDIF

      CASE nKey == K_ALT_S .AND. lDevelop    // save screen info
         IF LEN( aFlds ) == 0
            aFlds := Save3270( cScreen, "ALL" )
         ELSE
            Alert( "Screen information already saved.", {"OK"} )
         ENDIF

      CASE nKey == K_ALT_W .AND. lDevelop    // write the screen to disk
         IF LEN( aFlds ) == 0
            Alert( "No screen information saved yet!", {"OK"} )
         ELSE
            Write3270( "hostinfo.txt", cScreen, aFlds )
         ENDIF

      OTHERWISE
         TONE(100,1)
      ENDCASE

      IF nKey < 0 .OR. nKey == K_ENTER .OR. nKey == K_CTRL_RET
         * Display 3270 "clock" icon and wait for it to clear.
         SET CURSOR OFF
         @ 24,09 SAY "X ()" COLOR "N/W"   // show clock symbol
         CP2ready(1,2)                    // wait for Host to be ready
         @ 24,09 SAY "    " COLOR "N/W"   // erase clock symbol
         SET CURSOR ON
      ENDIF

      IF nKey <> 251
         cScreen := CP2readall()   // read screen image for changes
      ENDIF

   ENDDO

END SEQUENCE

* Stuff a key in keyboard and yank it out.  This will set LASTKEY() to
* a value other than K_ESC.
KEYBOARD CHR( K_ENTER )
INKEY()

* Reset attribute in case it is was changed.
CP2attrib( nOldAttr )

SETCOLOR ( cOldColor )
RestBox( cSaveScrn )

RETURN .T.

*: EOF: HOST3270.PRG
