*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\PROG3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: PROG3270()
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
#include "CLIP2.CH"
#include "FILEIO.CH"

*!*****************************************************************************
*!
*!       Function: PROG3270()
*!
*!      Called by: HOST3270()         (function  in HOST3270.PRG)
*!
*!    Other Files: CFILENAME
*!
*!*****************************************************************************
FUNCTION Prog3270( cFileName, cScreen, aFlds )
* 03/09/93 - Create a Clipper function to edit the screen.
LOCAL nHandle, nLoop, lProtect := .F.

IF FILE( cFileName )
   nHandle := FOPEN( cFileName, FO_WRITE )
   FSEEK( nHandle, 0, FS_END )
   FWRITELN( nHandle, REPLICATE("*",80) )
   FWRITELN( nHandle, " " )
ELSE
   nHandle := FCREATE( cFileName )
ENDIF

FWRITELN( nHandle, "FUNCTION HostScrn()" )
FWRITELN( nHandle, "LOCAL Getlist := {}" )
* Declare the variables and get data from mainframe screen.
FOR nLoop := 2 TO LEN( aFlds )
   FWRITELN( nHandle, "LOCAL c"+;
      IF(aFlds[nLoop,1] $ "Edit~Hide", "Data", "Text" )+;
      STRZERO(nLoop-1,3,0)+" := "+;
      "CP2readat( "+LTRIM(STR(aFlds[nLoop,2]))+", "+;
      LTRIM(STR(aFlds[nLoop,3]))+", "+LTRIM(STR(aFlds[nLoop,4]))+" )" )
NEXT
FWRITELN( nHandle, " " )

* Create the SAY/GET variables to display the screen.
FOR nLoop := 2 TO LEN( aFlds )
   FWRITELN( nHandle, "@ "+;
      STRZERO(aFlds[nLoop,2],2)+","+;
      STRZERO(aFlds[nLoop,3],2)+" "+;
      IF(aFlds[nLoop,1] $ "Edit~Hide", "GET", "SAY" )+;
      " c"+IF(aFlds[nLoop,1] $ "Edit~Hide", "Data", "Text" )+;
      STRZERO(nLoop-1,3,0)+" COLOR ["+aFlds[nLoop,8]+"]"+;
      IF(aFlds[nLoop,1] = "Hide", " PROTECT", "" ) )
   * Check for protected fields
   IF aFlds[nLoop,1] = "Hide"
      lProtect := .T.
   ENDIF
NEXT

FWRITELN( nHandle, IF(lProtect, "READ PROTECT", "READ") )
FWRITELN( nHandle, " " )

* Declare the variables and get data from mainframe screen.
FWRITELN( nHandle, "IF UPDATED()" )
FOR nLoop := 2 TO LEN( aFlds )
   IF aFlds[nLoop,1] $ "Edit~Hide"
      FWRITELN( nHandle, "   CP2writeat( "+LTRIM(STR(aFlds[nLoop,2]))+", "+;
         LTRIM(STR(aFlds[nLoop,3]))+", TRIM(cData"+STRZERO(nLoop-1,3,0)+") )" )
   ENDIF
NEXT
FWRITELN( nHandle, "ENDIF" )
FWRITELN( nHandle, " " )
FWRITELN( nHandle, "RETURN .T." )
FWRITELN( nHandle, " " )

FCLOSE( nHandle)

TONE(240, 0.25)
TONE(480, 0.25)

RETURN .T.

*: EOF: PROG3270.PRG
