*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\SAVE3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: SAVE3270()
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
#include "CLIP2.CH"

*!*****************************************************************************
*!
*!       Function: SAVE3270()
*!
*!      Called by: HOST3270()         (function  in HOST3270.PRG)
*!
*!          Calls: FIELD3270()        (function  in FLD_3270.PRG)
*!               : COLOR3270()        (function  in COLR3270.PRG)
*!
*!*****************************************************************************
FUNCTION Save3270( cScreen, cAction )
LOCAL nCol := 0, nRow := 0, nCurSpot := 1, cChar, nLoop
LOCAL aFlds := {}, cFieldType := "????", cFieldColr := ""

STATUSBAR( 0, 1920, 10, "Saving screen information", "N/W" )

cScreen := IF( VALTYPE( cScreen ) <> "C", CP2aread(), cScreen )
cAction := IF( VALTYPE( cAction ) <> "C", "ALL", cAction )

* Get the current host cursor position
CP2AT( @nRow, @nCol )
AADD( aFlds, { nRow, nCol } )

DO WHILE nCurSpot < 1920
   cChar := SUBSTR( cScreen, nCurSpot, 1 )
   IF ASC( cChar ) > 127 .AND. cChar <> CHR(196)   // color attribute
      cFieldType := Field3270( cChar )
      cFieldColr := Color3270( cChar )
   ELSE
      IF cAction == "ALL" .OR. ;
            (cAction == "EDIT" .AND. cFieldType $ "Edit~Hide" )
         IF CP2FTYPEPN( nCurSpot ) <> "U"
            * Get information on this field.
            AADD( aFlds, { cFieldType,;
               CP2ROWPN( nCurSpot ),;
               CP2COLPN( nCurSpot ),;
               CP2FLENP( nCurSpot ),;
               IF( CP2FPROTPN( nCurSpot ) = 1, "Y", "N"),;
               IF( CP2FUPDPN( nCurSpot ) = 1, "Y", "N"),;
               nCurSpot,;
               cFieldColr } )
            nCurSpot += CP2FLENP( nCurSpot ) - 1
         ENDIF
      ENDIF
   ENDIF
   nCurSpot ++
   STATUSBAR( nCurSpot )
ENDDO

STATUSBAR( 0 )

RETURN aFlds

*: EOF: SAVE3270.PRG
