*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\SHOW3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: SHOW3270()
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
#include "CLIP2.CH"

*!*****************************************************************************
*!
*!       Function: SHOW3270()
*!
*!      Called by: HOST3270()         (function  in HOST3270.PRG)
*!
*!          Calls: COLOR3270()        (function  in COLR3270.PRG)
*!
*!*****************************************************************************
FUNCTION Show3270( cScreen, lAttrib, lStatus )
LOCAL nCol := 0, nRow := 0, nCurSpot, cSchar, cOldColor, cCurColr

lAttrib := IF( VALTYPE( lAttrib ) <> "L", .T., lAttrib )  // default attributes
lStatus := IF( VALTYPE( lStatus ) <> "L", .F., lStatus )  // default no status

IF VALTYPE( cScreen ) <> "C"
   cScreen := CP2readall()
ENDIF

IF lAttrib
   * Get the current host cursor position
   CP2AT( @nRow, @nCol )
   * Adjust for host position which is one line and column different.
   nCurSpot := ((nRow-1) * 80) + nCol
   
   cOldColor := SETCOLOR( Color3270(9) )
   nRow := 0
   DO WHILE nRow <= 23
      nCol := 0
      DO WHILE nCol <= 79
         cSchar := SUBSTR( cScreen, (nRow*80)+nCol+1, 1 )
         IF ASC( cSchar ) > 127   // color attribute
            @ nRow, nCol SAY " "  //COLOR Color3270(9)  // normal text color
            SETCOLOR( Color3270( cSchar ) )
         ELSE
            @ nRow, nCol SAY cSchar
         ENDIF
         IF nCurSpot == (nRow*80)+nCol+1
            cCurColr := SETCOLOR()
         ENDIF
         nCol ++
      ENDDO
      nRow ++
   ENDDO
   SETCOLOR( cOldColor )
ELSE
   DISPBEGIN()
   FOR nRow := 0 TO 23
      @ nRow,00 SAY SUBSTR( cScreen, (nRow*80)+1 , 80 )
   NEXT
   DISPEND()
   cCurColr := SETCOLOR()
ENDIF

* Display the 3270 status line
IF lStatus
   Stat3270()
ENDIF

RETURN cCurColr

*: EOF: SHOW3270.PRG
