*:*****************************************************************************
*:
*: Procedure file: C:\TEMP\TURN3270.PRG
*:
*:         System: 3270 emulation program
*:         Author: John Wright
*:      Copyright (c) 1992-1993, John Wright
*:  Last modified: 12/26/93      8:30
*:
*:  Procs & Fncts: TURN3270()
*:
*:      Documented 12/26/93 at 08:35                SNAP!  version 5.02
*:*****************************************************************************
#include "CLIP2.CH"

*!*****************************************************************************
*!
*!       Function: TURN3270()
*!
*!      Called by: HOST3270()         (function  in HOST3270.PRG)
*!
*!*****************************************************************************
FUNCTION TURN3270( cAction, cType, lSlowcpu )
STATIC lActive := .F., cSession := "E"
* Session A = Network 3270
* Session E = DCA/IRMA
IF VALTYPE( cType ) == "C"
   cSession := cType
ENDIF
lSlowcpu := IF( VALTYPE( lSlowcpu ) <> "L", .F., lSlowcpu )

IF UPPER(cAction) == "ON" .AND. !lActive     // Start-Up Clip2++
   IF CP2INIT() <> CP2SUCCESS
      Alert( "Unable to find PC-host connection!;;"+;
         "Make sure 3270 emulation software;"+;
         "and HLLAPI are loaded in memory.", {"OK"} )
      RETURN .F.
   ENDIF

   ** Connect to a Host Session
   IF CP2CONNECT( cSession ) <> CP2SUCCESS
      Alert( "Error connecting to current host session.;"+Cp2errstr(), {"OK"} )
      RETURN .F.
   ENDIF
   CP2attrib( IF( lSlowcpu, 0, 1 ) )  // turn screen attributes on?
   lActive := .T.
ENDIF

IF UPPER(cAction) == "OFF" .AND. lActive     // Finish Clip2++
   IF CP2DISCON( cSession ) <> CP2SUCCESS
      Alert( "Error disconnecting from current host session.;"+Cp2errstr(), {"OK"} )
      RETURN .F.
   ENDIF
   lActive := .F.
ENDIF

RETURN .T.

*: EOF: TURN3270.PRG
